package com.ruoyi.ehsMaterialDetail.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.common.utils.StringUtils;
import java.util.List;
import java.util.Map;
import com.ruoyi.ehsMaterialDetail.mapper.EhsMaterialDetailMapper;
import com.ruoyi.ehsMaterialDetail.domain.EhsMaterialDetail;
import com.ruoyi.ehsMaterialDetail.service.IEhsMaterialDetailService;

/**
 * 资源管理出库入库明细Service业务层处理
 *
 * @author ruoyi
 * @date 2023-12-05
 */
@Service
public class EhsMaterialDetailServiceImpl extends ServiceImpl<EhsMaterialDetailMapper, EhsMaterialDetail> implements IEhsMaterialDetailService {

	@Autowired
	private EhsMaterialDetailMapper ehsMaterialDetailMapper;

	/**
	 * 查询资源管理出库入库明细
	 *
	 * @param materialDetailId 资源管理出库入库明细主键
	 * @return 资源管理出库入库明细
	 */
	@Override
	public EhsMaterialDetail selectEhsMaterialDetailByMaterialDetailId(Long materialDetailId)
	{
		return ehsMaterialDetailMapper.selectEhsMaterialDetailByMaterialDetailId(materialDetailId);
	}

	/**
	 * 查询资源管理出库入库明细列表
	 *
	 * @param ehsMaterialDetail 资源管理出库入库明细
	 * @return 资源管理出库入库明细
	 */
	@Override
	public List<EhsMaterialDetail> selectEhsMaterialDetailList(EhsMaterialDetail ehsMaterialDetail)
	{
		return ehsMaterialDetailMapper.selectEhsMaterialDetailList(ehsMaterialDetail);
	}
	/**
	 * 按主表id删除未执行指令的记录
	 *
	 * @param materialId 物资表ID
	 * @return 结果
	 */
	@Override
	public int deleteEhsMaterialDetailByMaterialId(Long materialId){
		return ehsMaterialDetailMapper.deleteEhsMaterialDetailByMaterialId(materialId);
	}

	private LambdaQueryWrapper<EhsMaterialDetail> buildQueryWrapper(EhsMaterialDetail query) {
		Map<String, Object> params = query.getParams();
		LambdaQueryWrapper<EhsMaterialDetail> lqw = Wrappers.lambdaQuery();
					lqw.eq(query.getMaterialId() != null, EhsMaterialDetail::getMaterialId, query.getMaterialId());
					lqw.eq(query.getSendUserId() != null, EhsMaterialDetail::getSendUserId, query.getSendUserId());
					lqw.eq(StringUtils.isNotBlank(query.getSendQuantity()), EhsMaterialDetail::getSendQuantity, query.getSendQuantity());
					lqw.eq(query.getSendTime() != null, EhsMaterialDetail::getSendTime, query.getSendTime());
					lqw.eq(query.getOutboundUserId() != null, EhsMaterialDetail::getOutboundUserId, query.getOutboundUserId());
					lqw.eq(StringUtils.isNotBlank(query.getOutboundQuantity()), EhsMaterialDetail::getOutboundQuantity, query.getOutboundQuantity());
					lqw.eq(query.getOutboundTime() != null, EhsMaterialDetail::getOutboundTime, query.getOutboundTime());
				lqw.orderByDesc(EhsMaterialDetail::getCreateTime);
					lqw.eq(query.getDeptId() != null, EhsMaterialDetail::getDeptId, query.getDeptId());
		return lqw;
	}

}
